/***** Drill-and-Practice Program *****/
/* This program generates random drill-and-practice addition
 * problems.  Problems that are answered incorrectly on the first
 * attempt are queued and asked again at the end of the session.
 *
 * Input:  Number of problems to generate, student's answers to
 *         problems
 * Output: Messages, problems, correct answers, number of problems
 *         answered correctly
 *
 *******************************************************************/

#include "AdditionProblem.h"  // ArithmeticProblem
#include <queue>              // C++ standard queue container
#include <iostream>           // cin, cout, >>, <<

int main()
{
  int numProblems,            // number of problems asked
      maxAddend;              // maximum addend in a problem
  cout << "How many problems would you like? ";
  cin >> numProblems;
  cout << "What's the largest addend you would like? ";
  cin >> maxAddend;

  queue<AdditionProblem>      // C++ standard queue container
             wrongQueue;      // queue of problems missed

  // Carry out round 1 of the practice drill

  AdditionProblem problem;    // an addition problem
  int userAnswer;             // user's answer to problem
  for (int count = 1; count <= numProblems; count++)
  {
    problem.Get(maxAddend);
    problem.Display(cout);
    cin >> userAnswer;
    if (problem.Correct(userAnswer))
       cout << "Correct!\n\n";
    else
    {
      cout << "Sorry -- Try again later\n\n";
      wrongQueue.push(problem);
    }
  }

  // Now reask any problems student missed

  cout << "\nIf you got any problems wrong, you will now be given"
          "\na second chance to answer them correctly.\n";
  int wrong = 0;             // number gotten wrong on both tries
  while (!wrongQueue.empty())
  {
    problem = wrongQueue.front();
    wrongQueue.pop();
    problem.Display(cout);
    cin >> userAnswer;
    if (problem.Correct(userAnswer))
       cout << "Correct!\n\n";
    else
    {
      cout << "Sorry -- correct answer is "
           << problem.Answer() << "\n\n";
      wrong++;
    }
  }
  cout << "\nYou answered " << wrong << " problem"
       << (wrong > 1 ? "s " : " " ) << "incorrectly\n";
}
